using System;
using MIF.Primitives;
using System.IO;
using System.Collections;
using System.Text;
using MyUtils;

/// <summary>
/// Summary description for Class1
/// </summary>
namespace MIF
{
    public class CommandReader:FileStream
    {
        Encoding mEncoding;
        private Queue mLines;
        
  
        private const int BUFSIZE=8000;
        public CommandReader(string aFile,Encoding aEncoding)
        :base(aFile,FileMode.OpenOrCreate )
        {
            mEncoding = aEncoding;
            mLines = new Queue();
        }

        public string ReadLine()
        {
            if (mLines.Count > 0) 
                    return (mLines.Dequeue() as string);
            byte[] buf = new byte[BUFSIZE];
            string[] lines = new string[0] ;
            StringBuilder sb =new StringBuilder();
            while (true)
            {
                int bytes_read = Read(buf, 0, buf.Length);
                if (bytes_read == 0) break; 
                sb.Append(mEncoding.GetString(buf, 0, bytes_read));
            }
            lines = Strings.Split(sb.ToString(), new char[] { '\r', '\n' });
            for (int i = 0; i < lines.Length ; i++) mLines.Enqueue(lines[i]);
            if (mLines.Count <= 0) return null;    
            return (mLines.Dequeue() as string);
        }


    }

    public class CommandWriter : FileStream
    {
        Encoding mEncoding;
        public CommandWriter(string aFile,Encoding aEncoding)
            : base(aFile,FileMode.CreateNew|FileMode.Truncate,FileAccess.Write)
        {
            mEncoding = aEncoding;
            
        }

        public void WriteLine(string aString)
        {
            aString = aString+"\r\n";
            byte[] tmp = mEncoding.GetBytes(aString);
            Write(tmp, 0, tmp.Length);           
        }
        public void Write(string aString)
        {
            byte[] tmp = mEncoding.GetBytes(aString);
            Write(tmp, 0, tmp.Length);
        }
        public void WriteLine()
        {
            byte[] tmp = mEncoding.GetBytes("\r\n");
            Write(tmp, 0, tmp.Length);
        }


    }
}
