using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using MyUtils.Controls;
using MIFMAIN;

namespace MyUtils.Controls
{
	/// <summary>
	/// Summary description for MainCtrls.
	/// </summary>
	public class MainCtrls : System.Windows.Forms.Control
	{
		private Pen m_pen;

		public System.Windows.Forms.Button btnMove;
		public ImageButton btnSelect;
		public System.Windows.Forms.Button btnZoomOut;
		public System.Windows.Forms.Button btnNone;
		public System.Windows.Forms.Button btnZoomIn;

		public ImageButton btnRegion;
		public ImageButton btnPline;
		public ImageButton btnLine;
		public ImageButton btnPoint;
	
		public MainCtrls()
		{
			//
			// Required for Windows Form Designer support
			//
			
			InitializeComponent();
			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			m_pen = new Pen(Color.Black);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			//m_pen.Dispose();
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.btnNone	= new System.Windows.Forms.Button();
			this.btnMove	= new System.Windows.Forms.Button();
			this.btnSelect	= new ImageButton(SystemColors.Control);
			this.btnZoomOut = new System.Windows.Forms.Button();
			this.btnZoomIn	= new System.Windows.Forms.Button();
			// 
			// btnNone
			// 
			this.btnNone.Location = new System.Drawing.Point(84, 0);
			this.btnNone.Size = new System.Drawing.Size(21, 21);
			this.btnNone.Text = "N";
			this.btnNone.Click+= new System.EventHandler(btnNone_Click);
			// 
			// btnMove
			// 
			this.btnMove.Location = new System.Drawing.Point(63, 0);
			this.btnMove.Size = new System.Drawing.Size(21, 21);
			this.btnMove.Text = "M";
			this.btnMove.Click+= new System.EventHandler(btnMove_Click);

			// 
			// btnSelect
			// 
			this.btnSelect.Location = new System.Drawing.Point(42, 0);
			this.btnSelect.Size = new System.Drawing.Size(21, 21);
			this.btnSelect.Text = "S";
			this.btnSelect.Click+= new System.EventHandler(btnSelect_Click);
			// 
			// btnZoomOut
			// 
			this.btnZoomOut.Location = new System.Drawing.Point(21, 0);
			this.btnZoomOut.Size = new System.Drawing.Size(21, 21);
			this.btnZoomOut.Text = "-";
			this.btnZoomOut.Click+= new System.EventHandler(btnZoomOut_Click);
			// 
			// btnZoomIn
			// 
			this.btnZoomIn.Location = new System.Drawing.Point(0, 0);
			this.btnZoomIn.Size = new System.Drawing.Size(21, 21);
			this.btnZoomIn.Text = "+";
			this.btnZoomIn.Click+= new System.EventHandler(btnZoomIn_Click);
			



			///////Primitives
			int offset = 105;
			this.btnRegion	= new ImageButton(SystemColors.Control);
			this.btnRegion.Image =  GLOBALS.Instance.ilPrimitivesImages.Images[3];
			
			this.btnPline	= new ImageButton(SystemColors.Control);
			this.btnPline.Image =  GLOBALS.Instance.ilPrimitivesImages.Images[2];
			
			this.btnLine	= new ImageButton(SystemColors.Control);
			this.btnLine.Image =  GLOBALS.Instance.ilPrimitivesImages.Images[1];
			
			this.btnPoint	= new ImageButton(SystemColors.Control);
			this.btnPoint.Image = GLOBALS.Instance.ilPrimitivesImages.Images[0];
			// 
			// btnRegion
			// 
			this.btnRegion.Location = new System.Drawing.Point(offset+3*21, 0);
			this.btnRegion.Size = new System.Drawing.Size(21, 21);
			this.btnRegion.Text = "R";
			this.btnRegion.Click += new System.EventHandler(btnRegion_Click);
			// 
			// btnPline
			// 
			this.btnPline.Location = new System.Drawing.Point(offset+2*21, 0);
			this.btnPline.Size = new System.Drawing.Size(21, 21);
			this.btnPline.Text = "PL";
			this.btnPline.Click += new System.EventHandler(btnPline_Click);
			// 
			// btnLine
			// 
			this.btnLine.Location = new System.Drawing.Point(offset+21, 0);
			this.btnLine.Size = new System.Drawing.Size(21, 21);
			this.btnLine.Text = "L";
			this.btnLine.Click += new System.EventHandler(btnLine_Click);
			// 
			// btnPoint
			// 
			this.btnPoint.Location = new System.Drawing.Point(offset, 0);
			this.btnPoint.Size = new System.Drawing.Size(21, 21);
			this.btnPoint.Text = "P";
			this.btnPoint.Click += new System.EventHandler(btnPoint_Click);
			// 
			// MainCtrls
			// 
			this.ClientSize = new System.Drawing.Size(189, 21);
			this.Controls.Add(this.btnNone);
			this.Controls.Add(this.btnMove);
			this.Controls.Add(this.btnSelect);
			this.Controls.Add(this.btnZoomOut);
			this.Controls.Add(this.btnZoomIn);
			this.Controls.Add(this.btnRegion);
			this.Controls.Add(this.btnPline);
			this.Controls.Add(this.btnLine);
			this.Controls.Add(this.btnPoint);
			this.Text = "MainCtrls";
			this.Click+= new System.EventHandler(MainControls_Click);

		}
		#endregion


		private void AdjustRadioEffect(ImageButton aClickedControl)
		{
			for (int i = 0; i < this.Controls.Count; i++)
			{
				if (this.Controls[i].Equals(aClickedControl)) continue;
				if (!(this.Controls[i] is ImageButton)) continue;
				(this.Controls[i] as ImageButton).Pushed = false;
			}
                
		}

		void MainControls_Click(object Sender,EventArgs e)
		{
			AdjustRadioEffect(Sender as ImageButton);
		}
		
		void btnNone_Click(object Sender,EventArgs e)
		{
			MainControls_Click(Sender,e);
		}
		void btnMove_Click(object Sender,EventArgs e)
		{
			MainControls_Click(Sender,e);
		}
		void btnSelect_Click(object Sender,EventArgs e)
		{
			MainControls_Click(Sender,e);
		}
		void btnZoomOut_Click(object Sender,EventArgs e)
		{
			MainControls_Click(Sender,e);
		}
		void btnZoomIn_Click(object Sender,EventArgs e)
		{
			MainControls_Click(Sender,e);
		}

		//Primitives

		
		void btnRegion_Click(object Sender,EventArgs e)
		{
			MainControls_Click(Sender,e);
		}
		void btnPline_Click(object Sender,EventArgs e)
		{
			MainControls_Click(Sender,e);
		}
		void btnLine_Click(object Sender,EventArgs e)
		{
			MainControls_Click(Sender,e);
		}
		void btnPoint_Click(object Sender,EventArgs e)
		{
			MainControls_Click(Sender,e);
		}
		
		
		

	
	}
}
