using System.Collections;
using System.Windows.Forms;
using System.Drawing;
using MyUtils.Controls;

namespace MIF.Primitives
{

    public class DESC_BITMAP
    {
        public int ID;
        public int X1;
        public int Y1;
        public int HEIGHT;
        public int WIDTH;
        public DESC_BITMAP(int aID, int aX1, int aY1, int aHEIGHT, int aWIDTH)
        {
            ID = aID;
            X1 = aX1;
            Y1 = aY1;
            HEIGHT = aHEIGHT;
            WIDTH = aWIDTH;
        }
        public override string ToString()
        {
            return string.Format("{0}",ID) ;
        }
    }

    public class DESC_SYMBOL_S : SortedList
    {
        public ImageList m_ImageList = null;
        public static void SetRectFromId(int aId, out Rectangle aRect)
        {
             aRect = new Rectangle();
            aId = aId - 31;
            int row = aId / 8;
            int col = aId - (row * 8);
            aRect.X = col * 25 + 1;
            aRect.Y = row * 25 + 1;
            aRect.Width = 25;
            aRect.Height = 25;
        }
        public DESC_SYMBOL_S()
            : base(37)
        {

            Rectangle rect;
            for (int i=31;i<68;i++)
            {
                SetRectFromId(i,out rect);
                DESC_BITMAP desc_symbol = new DESC_BITMAP(i, rect.X,rect.Y, rect.Height, rect.Width);
                Add(desc_symbol.ID, desc_symbol);
            }
            m_ImageList = new ImageList();
            for (int i = 0; i < Count; i++)
            {
                DESC_BITMAP dbmp = this.GetByIndex(i) as DESC_BITMAP;
                Bitmap bmp = new Bitmap(dbmp.WIDTH, dbmp.HEIGHT);
                Graphics gr = Graphics.FromImage(bmp);
                gr.DrawImage(MIFSymbol.mSymbols, 0, 0, new Rectangle(dbmp.X1, dbmp.Y1, dbmp.WIDTH, dbmp.HEIGHT), System.Drawing.GraphicsUnit.Pixel);
                m_ImageList.Images.Add(bmp);
                gr.Dispose();
            }
            

        }

       

        public void PutToCombo(ComboBox.ObjectCollection aItems)
        {
            
            aItems.Clear();
            for (int i = 0; i < Count; i++)
            {
                MyUtils.Strings.ItemsAdd(aItems,this.GetByIndex(i).ToString(),this.GetKey(i).ToString(),i);
            }
            
        }
    }


}