using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Collections;
using MIF;
using MIF.Primitives;

namespace MIFFile
{
    public partial class frmChooseSelectedObject : Form
    {
        public frmChooseSelectedObject()
        {
            InitializeComponent();
        }

        private ArrayList mObjects;
        
        public static bool Run(ArrayList aObjects,ref object aChosenObject)
        {
            aChosenObject = null;
            if ((aObjects == null) || (aObjects.Count <= 0)) return false;
            if (aObjects.Count == 1) { aChosenObject = aObjects[0]; return true; }
            frmChooseSelectedObject frm=null;
            try
            {
                frm = new frmChooseSelectedObject();
                frm.StartPosition = FormStartPosition.CenterScreen;
                frm.mObjects = aObjects;
                if (frm.ShowDialog() == DialogResult.OK)
                {
                    aChosenObject = aObjects[frm.lbMain.SelectedIndex];
                    return true;
                }
                return false;
            }
            finally
            {
              frm.Dispose();  
            }
        }

        private void frmChooseSelectedObject_Shown(object sender, EventArgs e)
        {
            try
            {
                lbMain.BeginUpdate();
                lbMain.Items.Clear();
                for (int i = 0; i < mObjects.Count; i++)
                {
                    if ( (mObjects[i] as BaseObject).Properties==null) continue;
                    lbMain.Items.Add((mObjects[i] as BaseObject).Properties.ConvertToString(','));
                }
                if (lbMain.Items.Count > 0) lbMain.SelectedIndex = 0;
                lbMain.Focus();
            }
            finally
            {
                lbMain.EndUpdate();
            }
        }

    

        private void listBox1_Enter(object sender, EventArgs e)
        {
            if ((lbMain.Items.Count > 0) && (lbMain.SelectedIndex < 0))
            {
                lbMain.SelectedIndex = 0;
            }
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.Cancel;
            Close();
        }

        private void frmChooseSelectedObject_KeyDown(object sender, KeyEventArgs e)
        {
            switch (e.KeyCode)
            {
                case Keys.Return: btnOk_Click(btnOk,e); break;
                case Keys.Escape: btnCancel_Click(btnCancel,e); break;
            }
        }

        private void btnOk_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.OK;
            Close();
        }

        private void lbMain_DoubleClick(object sender, EventArgs e)
        {
            btnOk_Click(btnOk,null);
        }

   


    }
}