using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace MIFFile
{
    public partial class frmChooseSymbol : Form
    {
        public frmChooseSymbol()
        {
            InitializeComponent();
            
        }
        public const int m_SymSize = 25;
        public const int m_SymOffset = 31;
        public const int m_SymCount = 36;
        private Pen curPen = null;
        private Graphics gr = null;
        private Bitmap init_image = null;
        private Rectangle rect = new Rectangle(1, 1, m_SymSize, m_SymSize);
        private int m_Shape=31;
        private bool PointerInRect(int x, int y, Rectangle aRect)
        {
            return (
                (aRect.X < x) &&
                (x< aRect.X + aRect.Width) &&
                (aRect.Y < y) &&
                (y< aRect.Y + aRect.Height)
                );
        }
        public int Shape { get { return m_Shape; } }
        public static int RectToId(Rectangle aRect)
        {
            return ((aRect.X / m_SymSize) + (aRect.Y / m_SymSize) * 8) + m_SymOffset;
        }
       
        
        private void pictureBox1_MouseMove(object sender, MouseEventArgs e)
        {
             if (rect.Contains(new Point(e.X,e.Y))) return;
             rect.X  = (e.X / m_SymSize) * m_SymSize + 1;
             rect.Y = (e.Y / m_SymSize) * m_SymSize + 2;
             pictureBox1.Image.Dispose();
             pictureBox1.Image = new Bitmap(init_image);
             gr = Graphics.FromImage(pictureBox1.Image);
             gr.DrawRectangle(curPen, rect);
             pictureBox1.Invalidate();
             gr.Dispose();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            curPen = new Pen(Color.Black);
            init_image = new Bitmap(pictureBox1.Image);
            pictureBox1_MouseMove(null, new MouseEventArgs(MouseButtons.None, 0, 0, 0, 0));
        }

        private void pictureBox1_Click(object sender, EventArgs e)
        {
            if ((RectToId(rect) < m_SymOffset) || (RectToId(rect) > (m_SymOffset+m_SymCount))) return;
            m_Shape = RectToId(rect);
            DialogResult = DialogResult.OK;
            Close();
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            DialogResult = DialogResult.Cancel;
            Close();
        }

        public static bool Run(int aShapeIn, out int aShapeOut,int x,int y)
        {
            aShapeOut = aShapeIn;
            using (frmChooseSymbol frm = new frmChooseSymbol())
            {
                frm.CenterToScreen();
                frm.FormBorderStyle = FormBorderStyle.None;
                frm.MinimizeBox = frm.MaximizeBox = frm.ControlBox = false;
                frm.ShowInTaskbar = false;
                //frm.CenterToScreen();
                frm.Location = new Point(x, y);
                
                if (frm.ShowDialog() == DialogResult.Cancel) return false;
                aShapeOut = frm.Shape;
                return true;
            }
        }


        
    }
}