using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using MyUtils;
using System.Collections;
using MIF.Primitives;
using MyUtils.Controls;
using System.Threading;
using SerialIO;






namespace MIFFile
{
    public partial class frmMain : Form
    {
        public frmMain()
        {
            InitializeComponent();
        }

        private MIF.MIFFile m_MIFFile;
        private Bitmap m_Bitmap;
        private Graphics m_Graphics;
        private MousePointer m_MousePointer;
        private Point m_MouseDownPoint;
        private Point m_MouseMovePoint;
        private MouseEventArgs m_MouseDownEventArgs;
        private KeyEventArgs m_KeyDownEventArgs;
        private int m_Zoom_koef = 50000;
        private const int m_ZoomLimit   = 100;
        private int m_ZoomCnt     = 0;
        private ArrayList m_SelectedObjects;
        private ArrayList m_ClickedPoints = new ArrayList(0);
        private bool m_EndOper = true;
        private ArrayList m_tmpClickedPoints = new ArrayList(0);
        private MIFPolyLine pline =null;
        private MIFSection  section =null;
        private MIFRegion region = null;
        private Styles m_CurrentStyle = new Styles(MIF.Defaults.Symbol_Shape,MIF.Defaults.Line_width,MIF.Defaults.Line_color,MIF.Defaults.Brush_forecolor,MIF.Defaults.Symbol_Size);
        private ColorPaletteDialog m_ColorDialog=null;
        private bool mIsGPS = false;
        private Random rnd = new Random();
        private GPS m_GPS;
        private int cnt_opers = 0;
        private SIO m_SIO;
        private MyNMEA.CNMEAParser m_Parser;
        private const int BUFSIZE = 256;
        byte[] buf = new byte[BUFSIZE];
        private ArrayList m_GPSRawStrings;
        


        private bool MousePointerDraw(MousePointer aMousePointer)
        {
            return
                     (
                        (aMousePointer == MousePointer.Point) ||
                        (aMousePointer == MousePointer.Line) ||
                        (aMousePointer == MousePointer.PLine) ||
                        (aMousePointer == MousePointer.Region)
                    );
        }

        private void SetGpsState()
        {
            fileToolStripMenuItem.Enabled      = !mIsGPS;
            if (mIsGPS)
                btnGPS.BackColor = Color.Green;
            else btnGPS.BackColor = SystemColors.Control;
            //btnZoomOut.Enabled  = !mIsGPS;
            //btnMove.Enabled     = !mIsGPS;
            //btnSelect.Enabled   = !mIsGPS;
            //btnNone.Enabled     = !mIsGPS;
        }
        private void Undo()
        {
            if (m_ClickedPoints.Count> 0) 
            {
                m_ClickedPoints.Clear();
                region = null;
                pline = null;
                
                //endOperToolStripMenuItem_Click(null, null);
                m_EndOper = true;
                pnlControl.Enabled = true;
                pnlStyles.Enabled = true;
                fileToolStripMenuItem.Enabled = !mIsGPS;
                btnGPS.Enabled = true;
                m_MIFFile.Draw(pbMain.Image as Bitmap); 
                pbMain.Invalidate();
                return;
            }
            
            BaseObject last_object = m_MIFFile.mMIFData.Objects[m_MIFFile.mMIFData.Objects.Count - 1] as BaseObject;
            if (last_object is MIFRegion)
            {
                MIFRegion region = (last_object as MIFRegion);
                MIFSection section = region.mSections[0] as MIFSection;
                int NodeIdx = section.Nodes.Count - 1;
                section.RemoveAt(NodeIdx-1);
                if (section.Nodes.Count <= 2)
                {
                    m_MIFFile.RemoveAt(m_MIFFile.mMIFData.Objects.Count - 1);
                    cnt_opers--;
                }
            }
            else if (last_object is MIFPolyLine)
            {
                MIFPolyLine pline = (last_object as MIFPolyLine);
                MIFSection section = pline.mSections[0] as MIFSection;
                int NodeIdx = section.Nodes.Count - 1;
                section.RemoveAt(NodeIdx);
                if (section.Nodes.Count <= 1)
                {
                    m_MIFFile.RemoveAt(m_MIFFile.mMIFData.Objects.Count - 1);
                    cnt_opers--;
                }
            }
            else
            {
                m_MIFFile.RemoveAt(m_MIFFile.mMIFData.Objects.Count - 1);
                cnt_opers--;
            }
            m_MIFFile.Draw(pbMain.Image as Bitmap);
            pbMain.Invalidate();

        }
        private void AdjustPnlRadio(Panel aPanel,Control aClickedControl)
        {
            aClickedControl.BackColor = Color.Green;
            for (int i = 0; i < aPanel.Controls.Count; i++)
            {
                if (aPanel.Controls[i] == aClickedControl) continue;
                aPanel.Controls[i].BackColor = SystemColors.Control;
            }
                
        }


        private void PrepareForm()
        {
            //cbSymbolID.Width = cbSymbolSize.Width;
            //cbSymbolID.Location = new Point(cbSymbolSize.Location.X - cbSymbolID.Width,cbSymbolSize.Location.Y);
            //cbSymbolID.DropDownStyle = ComboBoxStyle.DropDownList;
            //cbSymbolID.ImageList = MIFSymbol.desc_symbol_s.m_ImageList;
            //cbSymbolID.SelectedIndexChanged += new System.EventHandler(this.toolcbSymbolID_SelectedIndexChanged);
            //pnlStyles.Controls.Add(cbSymbolID);
            //MIFSymbol.PutToComboShape(cbSymbolID.Items);
            try
            {
                MIFSymbol.PutToComboSize(cbSymbolSize.Items);
            }
            catch (TypeInitializationException e)
            {
                MessageBox.Show(e.InnerException.Message);
            }

            MIFLine.PutToComboLineWidth(cbLineWidth.Items);
            //Strings.ComboFind(cbSymbolID, m_CurrentStyle.SymbolID.ToString());
            Strings.ComboFind(cbSymbolSize, m_CurrentStyle.SymbolSize.ToString());
            Strings.ComboFind(cbLineWidth, m_CurrentStyle.LineWidth.ToString());

            btnBorderColor.BackColor = MyConvert.Rgb24ToColor(m_CurrentStyle.LineColor);
            btnFillColor.BackColor   = MyConvert.Rgb24ToColor(m_CurrentStyle.SolidColor);
            btnNone_Click(btnNone, null);
            pnlControl.Enabled = false;
            pnlStyles.Enabled = false;
            pnlGPS.Enabled = false;
            saveToolStripMenuItem.Enabled = false;
            exitToolStripMenuItem.Enabled = false;
            m_MIFFile = null;
            MapTrans.IsInit = false;
            m_Graphics.Clear(Color.White);
            pbMain.Invalidate();
            lblStatus.Text = "";
            
        }

        private void CreateObjects()
        {
            
            m_Bitmap            = new Bitmap(pbMain.Width, pbMain.Height);
            m_Graphics          = Graphics.FromImage(m_Bitmap);
            pbMain.Image        = m_Bitmap;
            m_MouseDownPoint    = new Point();
            m_MouseMovePoint    = new Point();
            m_SelectedObjects   = new ArrayList();
            m_GPS = new GPS();
            m_SIO   = new SIO("COM1", "NMEA.txt", SIO.Source.FILE);
            m_Parser = new MyNMEA.CNMEAParser();
            m_GPSRawStrings = new ArrayList();
        }
           

        private void DisposeObjects()
        {
            m_Bitmap.Dispose();
            m_Graphics.Dispose();
            m_SIO.Dispose();
        }

        private void openToolStripMenuItem_Click(object sender, EventArgs e)
        {
            odMIF.InitialDirectory = @".\";
            odMIF.Filter = @"MIF files(*.MIF)|*.MIF";
            odMIF.RestoreDirectory = true;
            if (odMIF.ShowDialog() != DialogResult.OK) return;
            m_MIFFile = new MIF.MIFFile(odMIF.FileName);
            if (!m_MIFFile.Read()) { MessageBox.Show("Error reading file!"); return; };
            if (!m_MIFFile.DrawInit(pbMain)) { MessageBox.Show("Error reading file!"); return; };
            this.Text = odMIF.FileName;
            m_SelectedObjects.Clear();
            pline   = null;
            section = null;
            region  = null;
            pnlControl.Enabled = true;
            pnlStyles.Enabled = true;
            pnlGPS.Enabled = true;
            btnNone_Click(btnNone, null);
            m_ClickedPoints.Clear();
            saveToolStripMenuItem.Enabled = true;
            exitToolStripMenuItem.Enabled = true;
            m_ZoomCnt = 0;
        }

        private void frmMain_Load(object sender, EventArgs e)
        {
            CreateObjects();
        }

        private void btnZoomIn_Click(object sender, EventArgs e)
        {
            m_MousePointer = MousePointer.ZoomIn;
            pbMain.Cursor = Cursors.Cross;
            AdjustPnlRadio(pnlControl, sender as Control);
        }

        private void btnZoomOut_Click(object sender, EventArgs e)
        {
            m_MousePointer = MousePointer.ZoomOut;
            pbMain.Cursor = Cursors.Cross;
            AdjustPnlRadio(pnlControl, sender as Control);
        }

        private void btnMove_Click(object sender, EventArgs e)
        {
            
            m_MousePointer = MousePointer.Move;
            pbMain.Cursor = Cursors.Hand;
            AdjustPnlRadio(pnlControl, sender as Control);
           
        }

        private void btnSelect_Click(object sender, EventArgs e)
        {
            m_MousePointer = MousePointer.Select;
            pbMain.Cursor = Cursors.Arrow;
            AdjustPnlRadio(pnlControl, sender as Control);
        }

        private void btnNone_Click(object sender, EventArgs e)
        {
            m_MousePointer = MousePointer.None;
            pbMain.Cursor = Cursors.Default;
            AdjustPnlRadio(pnlControl, sender as Control);
            SetState(false, false, false);
        }

        private void btnPoint_Click(object sender, EventArgs e)
        {
            m_MousePointer = MousePointer.Point;
            pbMain.Cursor = Cursors.Cross;
            AdjustPnlRadio(pnlControl, sender as Control);
            SetState(true,false,false);
        }

        private void SetState(bool IsPoint,bool IsLines,bool IsRegion)
        {
            pnlSym.Enabled           = IsPoint;
            cbSymbolSize.Enabled     = IsPoint;
            cbLineWidth.Enabled      = IsRegion || IsLines;
            btnBorderColor.Enabled   = IsRegion || IsLines;
            btnFillColor.Enabled     = IsRegion ;
             
        }

        private void btnLine_Click(object sender, EventArgs e)
        {
            m_MousePointer = MousePointer.Line;
            pbMain.Cursor = Cursors.Cross;
            AdjustPnlRadio(pnlControl, sender as Control);
            SetState(false, true, false);
        }
       

        private void btnPLine_Click(object sender, EventArgs e)
        {
            m_MousePointer  = MousePointer.PLine;
            pbMain.Cursor   = Cursors.Cross;
            m_EndOper     = false;
            AdjustPnlRadio(pnlControl, sender as Control);
            SetState(false,true,false);
        }

        private void btnRegion_Click(object sender, EventArgs e)
        {
            m_MousePointer  = MousePointer.Region;
            pbMain.Cursor   = Cursors.Cross;
            m_EndOper     = false;
            AdjustPnlRadio(pnlControl, sender as Control);
            SetState(false, false, true);
            
        }


        private void pbMain_MouseDown(object sender, MouseEventArgs e)
        {
            if (mIsGPS) return;
            m_MouseDownEventArgs = e;
            m_MouseDownPoint.X = e.X;
            m_MouseDownPoint.Y = e.Y;
            
            if (e.Button != MouseButtons.Left) return;

        }

      

        private void pbMain_MouseMove(object sender, MouseEventArgs e)
        {
            
            m_MouseMovePoint.X = e.X;
            m_MouseMovePoint.Y = e.Y;
            if (m_MIFFile == null) return;
            if (!MapTrans.IsInit) return;
            PointDouble deg = MapTrans.GetDegree(m_MouseMovePoint);
            lblStatus.Text = string.Format("{0} lon ,{1} lat", deg.X, deg.Y);
            switch (m_MousePointer)
            {
                case MousePointer.Move:
                    if (e.Button != MouseButtons.Left) return;
                    m_MIFFile.Move(m_MouseDownPoint, m_MouseMovePoint, pbMain);
                    m_MouseDownPoint = m_MouseMovePoint;
                return;
            }

        }

        private void saveToolStripMenuItem_Click(object sender, EventArgs e)
        {
            /*
            sdMIF.InitialDirectory = @".\";
            sdMIF.Filter = @"MIF files(*.MIF)|*.MIF";
            sdMIF.RestoreDirectory = true;
            if (sdMIF.ShowDialog() != DialogResult.OK) return;
             */
            if (!m_MIFFile.Save()) MessageBox.Show(@"Error durring Save");
            else
                MessageBox.Show(@"Save successfull");
        }

        private void frmMain_KeyDown(object sender, KeyEventArgs e)
        {
            m_KeyDownEventArgs = e;
        }

        private void propToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (m_SelectedObjects == null) return;
            if (m_SelectedObjects.Count != 1) return;
            frmObjectProperties.Run((m_SelectedObjects[m_SelectedObjects.Count-1] as BaseObject));
        }

        private void deleteToolStripMenuItem_Click(object sender, EventArgs e)
        {
            m_MIFFile.Remove(m_SelectedObjects);
            m_MIFFile.Draw(pbMain.Image as Bitmap);
            pbMain.Invalidate();
        }

        private void frmMain_KeyUp(object sender, KeyEventArgs e)
        {
            m_KeyDownEventArgs = null;
        }

        private void contextMenuStrip1_Opening(object sender, CancelEventArgs e)
        {
            propToolStripMenuItem.Enabled = 
                            (btnSelect.BackColor == Color.Green) &&
                            (m_SelectedObjects.Count==1);
            deleteToolStripMenuItem.Enabled = propToolStripMenuItem.Enabled;
            endOperToolStripMenuItem.Enabled = !m_EndOper;
            undoToolStripMenuItem.Enabled = ( ((cnt_opers > 0) && (m_EndOper)) ||
                                            (m_ClickedPoints.Count>0) );
                            
        }

        private void endOperToolStripMenuItem_Click(object sender, EventArgs e)
        {
            m_EndOper           = true;
            pbMain_Click(pbMain,null) ;
            pnlControl.Enabled  = true;
            pnlStyles.Enabled   = true;
            fileToolStripMenuItem.Enabled  = !mIsGPS;
            btnGPS.Enabled      = true;
        }

        private void frmMain_Shown(object sender, EventArgs e)
        {
            PrepareForm();
        }

        private void toolcbSymbolID_SelectedIndexChanged(object sender, EventArgs e)
        {
            
        }

        private void tscbSymbolSize_SelectedIndexChanged(object sender, EventArgs e)
        {
            m_CurrentStyle.SymbolSize = int.Parse(Strings.ComboGet(cbSymbolSize));
            if (m_SelectedObjects.Count > 0)
            {
                BaseObject sel_object = m_SelectedObjects[0] as BaseObject;
                if (!(sel_object is MIFPoint)) return;
                if ((sel_object as MIFPoint).mSymbol.Size == int.Parse(Strings.ComboGet(cbSymbolSize)) ) return;
                (sel_object as MIFPoint).mSymbol.Size = int.Parse(Strings.ComboGet(cbSymbolSize));
                m_MIFFile.Draw(m_Bitmap);
                pbMain.Invalidate();
            }
        }

        private void tscbLineWidth_SelectedIndexChanged(object sender, EventArgs e)
        {
            m_CurrentStyle.LineWidth = int.Parse(Strings.ComboGet(cbLineWidth));
            if (m_SelectedObjects.Count > 0)
            {
                BaseObject sel_object = m_SelectedObjects[0] as BaseObject;
                if (sel_object is MIFPoint ) return;
                if (sel_object is MIFLine)
                {
                    (sel_object as MIFLine).MIFPen.Width = int.Parse(Strings.ComboGet(cbLineWidth));
                }
                if (sel_object is MIFPolyLine)
                {
                    (sel_object as MIFPolyLine).SetMIFPenWidth (int.Parse(Strings.ComboGet(cbLineWidth)));
                }
                if (sel_object is MIFRegion)
                {
                    (sel_object as MIFRegion).mMIFPen.Width = int.Parse(Strings.ComboGet(cbLineWidth));
                }
                
                m_MIFFile.Draw(m_Bitmap);
                pbMain.Invalidate();
            }
        }

        private void btnBorderColor_Click(object sender, EventArgs e)
        {
            using (m_ColorDialog = new ColorPaletteDialog(MousePosition.X, MousePosition.Y))
            {
                if (m_ColorDialog.ShowDialog() != DialogResult.OK) return;
                m_CurrentStyle.LineColor = MyConvert.ColorToRgb24(m_ColorDialog.Color);
                btnBorderColor.BackColor = m_ColorDialog.Color;
            }
            
            if (m_SelectedObjects.Count > 0)
            {
                BaseObject sel_object = m_SelectedObjects[0] as BaseObject;
                if (sel_object is MIFPoint) return;
                if (sel_object is MIFLine)
                {
                    if ((sel_object as MIFLine).MIFPen.MIFColor == MyConvert.ColorToRgb24(btnBorderColor.BackColor)) return;
                    (sel_object as MIFLine).MIFPen.MIFColor= MyConvert.ColorToRgb24(btnBorderColor.BackColor);
                }
                if (sel_object is MIFPolyLine)
                {
                    if ((sel_object as MIFPolyLine).MIFPen.MIFColor == MyConvert.ColorToRgb24(btnBorderColor.BackColor)) return;
                    (sel_object as MIFPolyLine).SetMIFPenColor(MyConvert.ColorToRgb24(btnBorderColor.BackColor));
                }
                if (sel_object is MIFRegion)
                {
                    if ((sel_object as MIFRegion).MIFPen.MIFColor == MyConvert.ColorToRgb24(btnBorderColor.BackColor)) return;
                    (sel_object as MIFRegion).SetMIFPenColor(MyConvert.ColorToRgb24(btnBorderColor.BackColor));
                }

                m_MIFFile.Draw(m_Bitmap);
                pbMain.Invalidate();
            }
        }

        private void btnFillColor_Click(object sender, EventArgs e)
        {
            using (m_ColorDialog = new ColorPaletteDialog(MousePosition.X, MousePosition.Y))
            {
                if (m_ColorDialog.ShowDialog() != DialogResult.OK) return;
                m_CurrentStyle.SolidColor = MyConvert.ColorToRgb24(m_ColorDialog.Color);
                btnFillColor.BackColor = m_ColorDialog.Color;
            }
            if (m_SelectedObjects.Count > 0)
            {
                BaseObject sel_object = m_SelectedObjects[0] as BaseObject;
                
                if (sel_object is MIFPoint) return;
                if (sel_object is MIFLine) return;
                if (sel_object is MIFPolyLine) return;
                if (sel_object is MIFRegion)
                {
                    if ((sel_object as MIFRegion).MIFBrush.MIFBackColor == MyConvert.ColorToRgb24(btnFillColor.BackColor)) return;
                    (sel_object as MIFRegion).SetMIFBrushColor(MyConvert.ColorToRgb24(btnFillColor.BackColor));
                }

                m_MIFFile.Draw(m_Bitmap);
                pbMain.Invalidate();
            }
        }

        private void DoOper()
        {
            if (m_MIFFile == null) return;
            switch (m_MousePointer)
            {
                case MousePointer.ZoomIn:
                            if (m_ZoomCnt == m_ZoomLimit) return;
                            m_MIFFile.Zoom(m_Zoom_koef, m_MouseDownPoint, pbMain);
                            m_ZoomCnt++;
                break;
                case MousePointer.ZoomOut:
                    if (m_ZoomCnt == 0) return;
                    m_MIFFile.Zoom(-m_Zoom_koef, m_MouseDownPoint, pbMain);
                    m_ZoomCnt--;
                break;
                case MousePointer.Select:
                    m_MIFFile.Select(m_MouseDownPoint, m_MouseDownEventArgs, m_KeyDownEventArgs, pbMain, m_SelectedObjects);
                    if (m_SelectedObjects.Count > 0)
                    {
                        if (m_SelectedObjects[0] is MIFPoint)
                        {
                            SetState(true, false, false);
                            m_CurrentStyle.SymbolID = (m_SelectedObjects[0] as MIFPoint).mSymbol.Shape;
                            pnlSym.Refresh();
                        }
                        if (m_SelectedObjects[0] is MIFLine)
                        {
                            SetState(false, true, false);
                            Strings.ComboFind(cbLineWidth, (m_SelectedObjects[0] as MIFLine).MIFPen.Width.ToString());
                            btnBorderColor.BackColor = (m_SelectedObjects[0] as MIFLine).MIFPen.Color;
                        }
                        if (m_SelectedObjects[0] is MIFPolyLine)
                        {
                            SetState(false, true, false);
                            Strings.ComboFind(cbLineWidth, (m_SelectedObjects[0] as MIFPolyLine).MIFPen.Width.ToString());
                            btnBorderColor.BackColor = (m_SelectedObjects[0] as MIFPolyLine).MIFPen.Color;
                        }
                        if (m_SelectedObjects[0] is MIFRegion)
                        {
                            SetState(false, true, true);
                            Strings.ComboFind(cbLineWidth, (m_SelectedObjects[0] as MIFRegion).MIFPen.Width.ToString());
                            btnBorderColor.BackColor = (m_SelectedObjects[0] as MIFRegion).MIFPen.Color;
                            btnFillColor.BackColor = (m_SelectedObjects[0] as MIFRegion).MIFBrush.BackColor;
                        }
                    }
                    break;
                case MousePointer.Point: m_MIFFile.DrawPoint(m_CurrentStyle, m_MouseDownPoint, pbMain,m_GPS.GPSRawMsg); m_EndOper = true;cnt_opers++; break;
                case MousePointer.Line:
                    
                    m_ClickedPoints.Add(m_MouseDownPoint);
                    m_GPSRawStrings.Add(m_GPS.GPSRawMsg);
                    if (m_ClickedPoints.Count == 2)
                    {
                        m_MIFFile.DrawLine(m_CurrentStyle, (Point)(m_ClickedPoints[0]), (Point)(m_ClickedPoints[1]), pbMain,m_GPSRawStrings);
                        m_ClickedPoints.Clear();
                        m_GPSRawStrings.Clear();
                        m_EndOper = true;
                        cnt_opers++;
                    }

                    break;
                case MousePointer.PLine:
                    if (pline == null)
                    {
                        m_EndOper = false;
                        pnlControl.Enabled = false;
                        pnlStyles.Enabled = false;
                        fileToolStripMenuItem.Enabled = false;
                        btnGPS.Enabled = false;
                        section = new MIFSection(new ArrayList(), SectionType.PolyLine, new MIFPen(m_CurrentStyle.LineWidth, MIF.Defaults.Pen_pattern, m_CurrentStyle.LineColor), new MIFBrush(MIF.Defaults.Pen_pattern, m_CurrentStyle.SolidColor, m_CurrentStyle.SolidColor));
                        pline = new MIFPolyLine(false, new MIFPen(m_CurrentStyle.LineWidth, MIF.Defaults.Pen_pattern, m_CurrentStyle.LineColor), new ArrayList());
                    }
                    if (!m_EndOper)
                    {
                        m_ClickedPoints.Add(m_MouseDownPoint);
                        m_GPSRawStrings.Add(m_GPS.GPSRawMsg);
                        MIFNode node = new MIFNode(MapTrans.GetDegree(m_MouseDownPoint).X, MapTrans.GetDegree(m_MouseDownPoint).Y, true);

                        section.AddNode(node);
                        if (m_ClickedPoints.Count >= 2)
                        {
                            section.Draw(pbMain.Image as Bitmap);
                            pbMain.Invalidate();
                        }
                    }
                    else
                    {
                        if (section.Nodes.Count > 1)
                        {
                            pline.AddSection(section);
                            pline.GPSRawStrings.AddRange(m_GPSRawStrings);
                            m_MIFFile.AddObject(pline);
                            cnt_opers++;
                        }
                        m_ClickedPoints.Clear();
                        m_GPSRawStrings.Clear();
                        pline = null;
                    }
                    break;
                case MousePointer.Region:
                    if (region == null)
                    {
                        m_EndOper = false;
                        pnlControl.Enabled = false;
                        pnlStyles.Enabled = false;
                        fileToolStripMenuItem.Enabled = false;
                        btnGPS.Enabled = false;
                        section = new MIFSection(new ArrayList(), SectionType.Polygon, new MIFPen(m_CurrentStyle.LineWidth, MIF.Defaults.Pen_pattern, m_CurrentStyle.LineColor), new MIFBrush(MIF.Defaults.Pen_pattern, m_CurrentStyle.SolidColor, m_CurrentStyle.SolidColor));
                        region  = new MIFRegion(new ArrayList(), new MIFPen(m_CurrentStyle.LineWidth, MIF.Defaults.Pen_pattern, m_CurrentStyle.LineColor), new MIFBrush(MIF.Defaults.Pen_pattern, m_CurrentStyle.SolidColor, m_CurrentStyle.SolidColor), new MIFNode(0, 0, true));
                    }

                    if (!m_EndOper)
                    {
                        m_ClickedPoints.Add(m_MouseDownPoint);
                        m_GPSRawStrings.Add(m_GPS.GPSRawMsg);
                        MIFNode node = new MIFNode(MapTrans.GetDegree(m_MouseDownPoint).X, MapTrans.GetDegree(m_MouseDownPoint).Y, true);
                        section.AddNode(node);
                        if (m_ClickedPoints.Count >= 2)
                        {
                            section.Draw(pbMain.Image as Bitmap);
                            pbMain.Invalidate();
                        }
                    }
                    else
                    {
                            if (m_ClickedPoints.Count >= 2)
                            {
                                section.AddNode(section.Nodes[0] as MIFNode);
                                section.Draw(pbMain.Image as Bitmap);
                                pbMain.Invalidate();
                            }
                            if (section.Nodes.Count > 1)
                            {
                                region.AddSection(section);
                                region.GPSRawStrings.AddRange(m_GPSRawStrings);
                                m_MIFFile.AddObject(region);
                                cnt_opers++;
                            }
                            m_ClickedPoints.Clear();
                            m_GPSRawStrings.Clear();
                            region = null;
                    }
                    break;
            }
        }

        private void undoToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Undo();
        }

        private void btnGPS_Click(object sender, EventArgs e)
        {
           mIsGPS = !mIsGPS;
           btnDraw.Enabled = mIsGPS;
           
           if (mIsGPS)
           {
               m_SIO.Open();
               m_Parser.Reset();
               timerSIOPool.Enabled = true;
               timerGetGPSDATA.Enabled = true;

           }
           else
           {
               timerSIOPool.Enabled = false;
               timerGetGPSDATA.Enabled = false;
               m_SIO.Close();
               m_MIFFile.Draw(pbMain.Image as Bitmap);
               pbMain.Invalidate();
           }
           SetGpsState();

        }

        private void timerSIOPool_Tick(object sender, EventArgs e)
        {
                try
                {
                    int bytesread = m_SIO.Read(buf, 0, buf.Length);
                    m_Parser.ParseBuffer(buf, bytesread);
                    Application.DoEvents();
                }
                catch (TimeoutException)
                {
                    m_Parser.Reset();
                }
        }

        private void pbMain_Click(object sender, EventArgs e)
        {
            if ( (mIsGPS) && (!m_EndOper) ) return;
            DoOper();
        }

        private void btnDraw_Click(object sender, EventArgs e)
        {
            if (!mIsGPS) return;
            DoOper();
        }

        private void pbMain_DoubleClick(object sender, EventArgs e)
        {
            PointDouble center = new PointDouble();
            center.X = m_MIFFile.mMIFData.GetMinX() + (m_MIFFile.mMIFData.GetMaxX() - m_MIFFile.mMIFData.GetMinX()) / 2;
            center.Y = m_MIFFile.mMIFData.GetMinY() + (m_MIFFile.mMIFData.GetMaxY() - m_MIFFile.mMIFData.GetMinY()) / 2;
            MapTrans.BasePoint  =  center;
            m_MIFFile.Draw(pbMain.Image as Bitmap);
            pbMain.Invalidate();
        }

        private void undoToolStripMenuItem_Click_1(object sender, EventArgs e)
        {
            Undo();
        }

        private void exitToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void frmMain_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = (MessageBox.Show("Exit?", "Confirm", MessageBoxButtons.YesNo) == DialogResult.No); 
                    
        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            PrepareForm();
            exitToolStripMenuItem.Enabled = false;
        }

        private void pnlSym_Paint(object sender, PaintEventArgs e)
        {

            if (((Control)sender).Enabled)
                MIFSymbol.DrawSymbol(e.Graphics, m_CurrentStyle.SymbolID);
            else
                e.Graphics.Clear(Color.Black);

        }

        private void pnlSym_Click(object sender, EventArgs e)
        {
            if (!frmChooseSymbol.Run(m_CurrentStyle.SymbolID, out m_CurrentStyle.SymbolID, 0, 0)) return;
            pnlSym.Invalidate();
            pnlSym.Refresh();
            if (m_SelectedObjects.Count > 0)
            {
                BaseObject sel_object = m_SelectedObjects[0] as BaseObject;
                if (!(sel_object is MIFPoint)) return;
                if ((sel_object as MIFPoint).mSymbol.Shape == m_CurrentStyle.SymbolID) return;
                (sel_object as MIFPoint).mSymbol.Shape = m_CurrentStyle.SymbolID;
                m_MIFFile.Draw(m_Bitmap);
                pbMain.Invalidate();
            }
        }


        private void timerGetGPSDATA_Tick(object sender, EventArgs e)
        {
            m_GPS.ReadFromParser(m_Parser);
            
            m_MouseDownPoint.X = m_GPS.PixCoordinates.X;
            m_MouseDownPoint.Y = m_GPS.PixCoordinates.Y;

            m_MIFFile.Draw(pbMain.Image as Bitmap);
            if (m_ClickedPoints.Count >= 2)
                section.Draw(pbMain.Image as Bitmap);
            m_GPS.DrawPosition(m_Graphics);
            pbMain.Invalidate();
            
        }


    }
}



//@"$GPRMC,,V,,,,,02.2,098.7,030707,04,E,N*27";
//@"$GPGSV,3,1,10,26,78,272,,29,78,213,,28,50,051,,17,41,123,*7A";
//@"$GPGSA,A,3,07,02,26,27,09,04,15,,,,,,1.8,1.0,1.5*33"; 
//@"$GPGLL,3723.2475,N,12158.3416,W,161229.487,A*2C";
//@"$GPGGA,161229.487,3723.2475,N,12158.3416,W,1,07,1.0,9.0,M,,,,0000*18";